<template>
  <transition name="modal-bottom">
    <div ref="bodyModal" key="2" class="modal__wrapper" @click="closeModal">
      <div class="modal-content" ref="modalContent" @click.stop="">
        <!-- header -->
        <div class="modal-header" v-if="title">
          <span class="modal-title"> {{ title }} </span>
        </div>
        <span
            class="button-close"
            title="close"
            @mousedown="setResize"
        ></span>
        <!-- body -->
        <div class="modal-body">
          <slot name="body"></slot>
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
export default {
  data () {
    return {
      isResizing: false,
      startPosition: 0,
      flag: false
    }
  },
  props: {
    title: {
      type: String,
      required: false
    },
    isClose: {
      type: Boolean,
      default: true
    },
  },
  methods: {
    closeModal () {
      this.$emit('close')
      document.body.style.overflow = 'visible'
    },
    /*
      RESIZE
    */
    setResize(e) {
      this.isResizing = true;
      this.startPosition = e.pageY;
      console.log(this.startPosition + '- start position')
    },
    endResize() {
      this.isResizing = false;
    },
    resizing(e) {
      if (!this.flag) this.startPosition = e.changedTouches[0].pageY
      this.flag = true
      if (this.flag) {
        // console.log(this.startPosition)
        if (!this.isResizing) {
          // return;
        }
        let walk = e.changedTouches[0].pageY - this.startPosition
        // if (walk < this.startPosition) return;
        this.$refs.modalContent.style.height = (this.$refs.modalContent.offsetHeight - walk) + 'px'
        if (this.$refs.modalContent.offsetHeight < 220) {
          this.isResizing = false
          this.closeModal()
        }
      }
    }
  },
  mounted () {
    document.body.addEventListener('keyup', e => {
      if (e.key === 'Escape') this.closeModal()
    })
    document.addEventListener("touchstart", this.endResize);
    document.addEventListener("touchmove", this.resizing);
  }
}
</script>

<style lang="scss" scoped>
  //animations
  .modal-bottom-enter, .modal-bottom-leave-active {
    opacity: 0;
  }
  .modal-bottom-animate-leave-active {
    transition: transform .6s ease, opacity .6s;
  }
  .modal-bottom-enter .modal-content,
  .modal-bottom-leave-active .modal-content {
    transform: translateY(320px);
  }
  .modal__wrapper{
    display: flex;
    justify-content: center;
    align-items: center;
    position: fixed;
    top: 0;
    left: 0;
    height: 100vh;
    transition: opacity .2s ease;
    right: 0;
    z-index: 990;
    background-color: rgba(00,00,00,.48);
  }
  .modal-content {
    position: fixed;
    bottom: 0;
    width: 100vw;
    min-height: 30vh;
    background-color: #fff;
    border: 1px solid #dcdfe6;
    transition: all .2s ease;
    border-radius: 12px 12px 0 0;
    z-index: 991;
    @media screen and (min-width: 900px) {
      min-width: 500px;
    }
  }
  .modal-header {
    display: flex;
    align-self: center;
    justify-content: space-between;
    padding-bottom: 20px;
    span {
      font-size: 24px;
    }
  }
  .button-close {
    position: absolute;
    left: calc(50% - 22px);
    top: 18px;
    cursor: pointer;
    width: 44px;
    height: 5px;
    transition: all .3s;
    background: #C4C4C4;
    border-radius: 100px;
    user-select: none;
    &:hover {
      transform: scale(1.1);
    }
  }
  .modal-body {
    text-align: center;
    margin-top: 20px;
    img {
      width: 100% !important;
      max-width: initial!important;
      border-radius: 5px;
    }
  }
  .modal-bottom {
    padding-top: 40px;
  }
  a.another-modal {
    color: #000;
    border-bottom: 1px solid #000;
  }
</style>
